PGSQL_CONTROL
-- $Id: aggregatex.m4,v 1.15 2006/04/13 02:25:02 babolo Exp $
\i PGSQL_CONTRIB/varbit

--  
CREATE AGGREGATE cat
     ( BASETYPE = text
     , SFUNC = textcat
     , STYPE = text
     , INITCOND = ''
     )
;
COMMENT ON AGGREGATE cat(text)           IS ' ';



--  bool  AND  OR --
---------------------------------
CREATE OR REPLACE FUNCTION bool_and(bool, bool) RETURNS bool
 AS 'SELECT $1 AND $2'
 LANGUAGE SQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION bool_and(bool, bool) IS '        ';

CREATE OR REPLACE FUNCTION bool_or(bool, bool) RETURNS bool
 AS 'SELECT $1 OR $2'
 LANGUAGE SQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION bool_or(bool, bool)  IS '        ';

CREATE AGGREGATE conjunction
     ( BASETYPE = bool
     , SFUNC = bool_and
     , STYPE = bool
     , INITCOND = 1
     )
;
COMMENT ON AGGREGATE conjunction(bool)   IS ' AND  bool';

CREATE AGGREGATE disjunction
     ( BASETYPE = bool
     , SFUNC = bool_or
     , STYPE = bool
     , INITCOND = 0
     )
;
COMMENT ON AGGREGATE disjunction(bool)   IS ' OR  bool';



--  varbit  AND  OR --
-----------------------------------
CREATE OR REPLACE FUNCTION varbitandN(bit, bit) RETURNS varbit
 AS 'SELECT CASE WHEN $1 IS NULL THEN $2 WHEN $2 IS NULL THEN $1 ELSE varbitand($1, $2) END
    '
 LANGUAGE SQL IMMUTABLE
;
COMMENT ON FUNCTION varbitandN(bit, bit) IS 'varbitand  ';

CREATE OR REPLACE FUNCTION varbitorN(bit, bit) RETURNS varbit
 AS 'SELECT CASE WHEN $1 IS NULL THEN $2 WHEN $2 IS NULL THEN $1 ELSE varbitor($1, $2) END
    '
 LANGUAGE SQL IMMUTABLE
;
COMMENT ON FUNCTION varbitorN(bit, bit)  IS 'varbitor  ';

CREATE AGGREGATE conjunction
     ( BASETYPE = bit
     , SFUNC = varbitandN
     , STYPE = varbit
     )
;
COMMENT ON AGGREGATE conjunction(bit)    IS ' AND  bit';

CREATE AGGREGATE disjunction
     ( BASETYPE = bit
     , SFUNC = varbitorN
     , STYPE = varbit
     )
;
COMMENT ON AGGREGATE disjunction(bit)    IS ' OR  bit';



--          --
---------------------------------------------------------------
CREATE OR REPLACE FUNCTION num2bit(varbit, integer) RETURNS varbit
 AS '$libdir/num2bit.so.VMAJOR'
  , 'num2bit'
 LANGUAGE C IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION num2bit(integer) RETURNS varbit
 AS 'SELECT num2bit(''''::varbit, $1)'
 LANGUAGE SQL IMMUTABLE STRICT
;
CREATE AGGREGATE num2bit_aggr
    ( BASETYPE = integer
    , SFUNC = num2bit
    , STYPE = varbit
    , INITCOND = 0
    )
;
CREATE OR REPLACE FUNCTION bit2num(varbit) RETURNS SETOF int4
 AS '$libdir/num2bit.so.VMAJOR'
  , 'bit2num'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION bit2num(varbit)       IS '   ,        ,       '
;
